structure FExamples = struct
  open Focusing 
  
  infixr 9 ^- ^+
  infixr 8 v
  infixr 7 >

  infix 5 ==>

  infix 4 left right stable

  infix 3 -- +--------- ========== +=
  infix 3 --- +-------- ========= +==
  infix 3 ---- +------- ======== +===
  infix 3 ----- +------ ======= +====
  infix 3 ------ +----- ====== +=====
  infix 3 ------- +---- ===== +======
  infix 3 -------- +--- ==== +=======
  infix 3 --------- +-- === +========
  infix 3 ---------- +- == +=========
  
  val imp_refl_pos : proof =
    []
    ---------- CAtomR
    right foc [up Ap] ==> Ap
    +--------- FocusR
    stable [up Ap] ==> Ap
    +--------- Stable
    left inv [up Ap] [] ==> Ap
    +--------- IAtomL
    left inv [] [Ap] ==> Ap
    +--------- IUpR
    right inv [] [Ap] ==> up Ap
    +--------- IImpR
    right inv [] [] ==> Ap > up Ap

  val imp_refl_neg : proof =
    
    []
    ---------- CAtomL
    left foc [An] An ==> down An
    +--------- FocusL
    stable [An] ==> down An
    +--------- Stable
    left inv [An] [] ==> down An
    +--------- IDownL
    left inv [] [down An] ==> down An
    +--------- IAtomR
    right inv [] [down An] ==> An
    +--------- IImpR
    right inv [] [] ==> down An > An
  
  val and_comm_neg : proof = 
    [
      []
      ----- CAtomR
      right foc [up Ap ^- up Bp, up Ap, up Bp] ==> Bp
    ,
      []
      ----- CAtomR
      right foc [up Ap ^- up Bp, up Ap, up Bp] ==> Ap
    ]
    ----- CAndR
    right foc [up Ap ^- up Bp, up Ap, up Bp] ==> Bp ^+ Ap
    +---- FocusR
    stable [up Ap ^- up Bp, up Ap, up Bp] ==> Bp ^+ Ap
    +---- Stable
    left inv [up Ap ^- up Bp, up Ap, up Bp] [] ==> Bp ^+ Ap
    +---- IAtomL
    left inv [up Ap ^- up Bp, up Ap] [Bp] ==> Bp ^+ Ap
    +---- CUpL
    left foc [up Ap ^- up Bp, up Ap] (up Bp) ==> Bp ^+ Ap
    +---- CAndL2
    left foc [up Ap ^- up Bp, up Ap] (up Ap ^- up Bp) ==> Bp ^+ Ap
    +---- FocusL
    stable [up Ap ^- up Bp, up Ap] ==> Bp ^+ Ap
    +---- Stable
    left inv [up Ap ^- up Bp, up Ap] [] ==> Bp ^+ Ap
    +---- IAtomL
    left inv [up Ap ^- up Bp] [Ap] ==> Bp ^+ Ap
    +---- CUpL
    left foc [up Ap ^- up Bp] (up Ap) ==> Bp ^+ Ap
    +---- CAndL1
    left foc [up Ap ^- up Bp] (up Ap ^- up Bp) ==> Bp ^+ Ap
    +---- FocusL
    stable [up Ap ^- up Bp] ==> Bp ^+ Ap
    +---- Stable
    left inv [up Ap ^- up Bp] [] ==> Bp ^+ Ap
    +---- IDownL
    left inv [] [down (up Ap ^- up Bp)] ==> Bp ^+ Ap
    +---- IUpR
    right inv [] [down (up Ap ^- up Bp)] ==> up (Bp ^+ Ap)
    +---- IImpR
    right inv [] [] ==> down (up Ap ^- up Bp) > up (Bp ^+ Ap)
end